/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.util.*;

public class RPC2_Init1Body extends RPC2_BodyStruct
{
	RPC2_NewConnectionBody FakeBody;
	int XRandom;
	RPC2_HostIdent SenderHost;
	RPC2_PortalIdent SenderPortal;
	int Uniquefier;
	int Spare1;
	int Spare2;
	int Spare3;
	byte Version[];
	byte Text[];

	// for CONSTRUCTING a packet
	public RPC2_Init1Body()
	{
	}

	// for READING a packet
	public RPC2_Init1Body(RPC2_Packet packet)
	{
		super(packet, "RPC2_Init1Body");
		FakeBody = new RPC2_NewConnectionBody(packet);
		XRandom = packet.getInt();
		SenderHost = new RPC2_HostIdent(packet);
		SenderPortal = new RPC2_PortalIdent(packet);
		Uniquefier = packet.getInt();
		Spare1 = packet.getInt();
		Spare2 = packet.getInt();
		Spare3 = packet.getInt();
		Version = packet.getBytes(96);
		Text = FakeBody.readClientIdent();
	}

	// for WRITING a packet
	public void encode(RPC2_Packet packet)
	{
		packet.put(FakeBody);
		packet.put(XRandom);
		packet.put(SenderHost);
		packet.put(SenderPortal);
		packet.put(Uniquefier);
		packet.put(Spare1);
		packet.put(Spare2);
		packet.put(Spare3);
		packet.put(Version, false);
		FakeBody.writeClientIdent(packet);
	}

	public String toString()
	{
		startPrint();
		addField("FakeBody", FakeBody);
		addField("XRandom", XRandom);
		addField("SenderHost", SenderHost);
		addField("SenderPortal", SenderPortal);
		addField("Uniquefier", Uniquefier);
		addField("Spare1", Spare1);
		addField("Spare2", Spare2);
		addField("Spare3", Spare3);
		addField("Version", "("+Version.length+","+new String(Version)+")");
		if (Text != null)
			addField("Text", "("+Text.length+","+new String(Text)+")");
		return getPrint();
	}

}

