/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.util.*;

public class RPC2_Init2Body extends RPC2_BodyStruct
{
	int XRandomPlusOne;
	int YRandom;
	int Spare1;
	int Spare2;
	int Spare3;

	// for CONSTRUCTING a packet
	public RPC2_Init2Body(int XRandomPlusOne, int YRandom)
	{
		this.XRandomPlusOne = XRandomPlusOne;
		this.YRandom = YRandom;
	}

	// for READING a packet
	public RPC2_Init2Body(RPC2_Packet packet)
	{
		super(packet, "RPC2_Init2Body");
		XRandomPlusOne = packet.getInt();
		YRandom = packet.getInt();
		Spare1 = packet.getInt();
		Spare2 = packet.getInt();
		Spare3 = packet.getInt();
	}

	// for WRITING a packet
	public void encode(RPC2_Packet packet)
	{
		packet.put(XRandomPlusOne);
		packet.put(YRandom);
		packet.put(Spare1);
		packet.put(Spare2);
		packet.put(Spare3);
	}

	public String toString()
	{
		startPrint();
		addField("XRandomPlusOne", XRandomPlusOne);
		addField("YRandom", YRandom);
		addField("Spare1", Spare1);
		addField("Spare2", Spare2);
		addField("Spare3", Spare3);
		return getPrint();
	}
}

