/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

public class RPC2_NewConnectionBody extends RPC2_BodyStruct
{
	int SideEffectType;
	int SecurityLevel;
	int EncryptionType;

	int ClientIdentLen;
	int ClientIdentCrypt;

	byte ClientIdent[];

	// for CONSTRUCTING a packet
	public RPC2_NewConnectionBody(int sideEffect, int secureLevel, int encType, byte cid[])
	{
		SideEffectType = sideEffect;
		SecurityLevel = secureLevel;
		EncryptionType = encType;
		ClientIdent = cid;
	}

	// for READING a packet
	public RPC2_NewConnectionBody(RPC2_Packet packet)
	{
		super(packet, "RPC2_NewConnectionBody");

		SideEffectType = packet.getInt();
		SecurityLevel = packet.getInt();
		EncryptionType = packet.getInt();
		ClientIdentLen = packet.getInt();
		ClientIdentCrypt = packet.getInt();
	}

	// for WRITING a packet
	public void encode(RPC2_Packet packet)
	{
		packet.put(SideEffectType);
		packet.put(SecurityLevel);
		packet.put(EncryptionType);
		packet.put(ClientIdentLen);
		packet.put(ClientIdentCrypt);
	}

	public byte[] readClientIdent()
	{
		ClientIdent = packet.getBytes(ClientIdentLen);
		return ClientIdent;
	}

	public void writeClientIdent(RPC2_Packet packet)
	{
		packet.put(ClientIdent, false);
	}

	public String toString()
	{
		startPrint();
		addField("SideEffectType", SideEffectType);
		addField("SecurityLevel", SecurityLevel);
		addField("EncryptionType", EncryptionType);
		addField("ClientIdentLen", ClientIdentLen);
		addField("ClientIdentCrypt", ClientIdentCrypt);
		if (ClientIdent != null)
			addField("ClientIdent", new String(ClientIdent));
		return getPrint();
	}
}

