/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.io.*;
import java.util.*;

public abstract class RPC2_Util
{
	public static String getHex(int val)
	{
		byte b[] = new byte[4];
		for (int i=0; i<4; i++)
			b[i] = (byte) ((val >> ((3-i)*8)) & 0xff);
		return getHex(b);
	}

	public static String getHex(byte b[])
	{
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<b.length; i++)
		{
			if (i % 2 == 0 && i > 0)
				sb.append(" ");
			sb.append(Character.forDigit((b[i] >> 4) & 0xF, 16));
			sb.append(Character.forDigit(b[i] & 0xF, 16));
		}
		return sb.toString();
	}

	public static byte[] getInt2(int val)
	{
		byte b[] = new byte[2];
		for (int i=0; i<2; i++)
			b[i] = (byte)(val >> ((1-i)*8));
		return b;
	}

	public static byte[] padBytes(byte b[], int pchar, int len)
	{
		byte newb[] = new byte[len];
		System.arraycopy(b,0,newb,0,b.length);
		for (int i=b.length; i<len; i++)
			newb[i] = (byte)pchar;
		return newb;
	}

	public static String padString(String str, int len)
	{
		return padString(str, ' ', len);
	}

	public static String padString(String str, int pchar, int len)
	{
		if (str.length() > len)
			return str.substring(0,len);
		StringBuffer sb = new StringBuffer(str);
		while (sb.length() < len)
			sb.append((char)pchar);
		return sb.toString();
	}
}

