/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

public class SE_Descriptor extends RPC2_BodyStruct
{
	public final static int SE_NOTSTARTED=33;
	public final static int SE_INPROGRESS=24;
	public final static int SE_SUCCESS=57;
	public final static int SE_FAILURE=36;

	int LocalStatus;
	int RemoteStatus;
	long Tag;			// only SMARTFTP or OMITSE

	SFTP_Descriptor Value;

	// for CONSTRUCTING a packet
	public SE_Descriptor()
	{
	}

	// for READING a packet
	public SE_Descriptor(RPC2_Packet packet)
	{
		super(packet, "SFTP_Descriptor");
		LocalStatus = packet.getInt();
		RemoteStatus = packet.getInt();
		Tag = packet.getInt();
		Value = new SFTP_Descriptor(packet);
	}

	// for WRITING a packet
	public void encode(RPC2_Packet packet)
	{
	}

	public String toString()
	{
		startPrint();
		addField("LocalStatus", LocalStatus);
		addField("RemoteStatus", RemoteStatus);
		addField("Tag", Tag);
		addField("Value", Value);
		return getPrint();
	}

}

