/**
 * Copyright (C) 1998 Stewart Allen (stewart@neuron.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

public class SFTP_Parms extends RPC2_BodyStruct
{
	RPC2_PortalIdent Portal;
	long WindowSize;
	long SendAhead;
	long AckPoint;
	long PacketSize;
	long DupThreshold;

	// for CONSTRUCTING a packet
	public SFTP_Parms(int portal)
	{
		super("SFTP_Parms");
		WindowSize = SFTP.DEFWINDOWSIZE;
		SendAhead = SFTP.DEFSENDAHEAD;
		AckPoint = 8;
		PacketSize = SFTP.DEFPACKETSIZE;
		DupThreshold = 16;
		Portal = new RPC2_PortalIdent(portal);
	}

	// for READING a packet
	public SFTP_Parms(RPC2_Packet packet)
	{
		super(packet, "SFTP_Parms");
		Portal = new RPC2_PortalIdent(packet);
		WindowSize = packet.getInt();
		SendAhead = packet.getInt();
		AckPoint = packet.getInt();
		PacketSize = packet.getInt();
		DupThreshold = packet.getInt();
	}

	// for WRITING a packet
	public void encode(RPC2_Packet packet)
	{
		packet.put(Portal);
		packet.put(WindowSize);
		packet.put(SendAhead);
		packet.put(AckPoint);
		packet.put(PacketSize);
		packet.put(DupThreshold);
	}

	public String toString()
	{
		startPrint();
		addField("Portal", Portal);
		addField("WindowSize", WindowSize);
		addField("SendAhead", SendAhead);
		addField("AckPoint", AckPoint);
		addField("PacketSize", PacketSize);
		addField("DupThreshold", DupThreshold);
		return getPrint();
	}

}

